#
# spec file for package apache2-mod_asn
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

Name:           apache2-mod_asn
BuildRequires:  apache2-devel apache2-prefork apache2-worker
%define apxs /usr/sbin/apxs2
%define apache apache2
%define apache_libexecdir %(%{apxs} -q LIBEXECDIR)
%define apache_sysconfdir %(%{apxs} -q SYSCONFDIR)
%define apache_includedir %(%{apxs} -q INCLUDEDIR)
%define apache_serverroot %(%{apxs} -q PREFIX)
%define apache_localstatedir %(%{apxs} -q LOCALSTATEDIR)
%define apache_mmn        %(MMN=$(%{apxs} -q LIBEXECDIR)_MMN; test -x $MMN && $MMN)
Version:        1.6
Release:        1.1
License:        Apache License, Version 2.0
Group:          Productivity/Networking/Web/Servers
Requires:       apache2 %{apache_mmn} 
Autoreqprov:    on
Summary:        mod_asn looks up the AS and network prefix of IP address
#
# http://svn.poeml.de/svn/mod_asn/trunk
Source0:	mod_asn-%{version}.tar.gz
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description

mod_asn is an Apache module doing lookups of the autonomous system (AS)[1], and
the network prefix[2] which contains a given (clients) IP address.

It is written with scalability in mind. To do high-speed lookups, it uses the
PostgreSQL ip4r datatype[3] that is indexable with a Patricia Trie[4] algorithm to
store network prefixes. This is the only algorithm that can search through the
~250.000 existing prefixes in a breeze.

It comes with script to create such a database (and keep it up to date) with
snapshots from global routing data - from a router's "view of the
world", so to speak.

Apache-internally, the module sets the looked up data as env table variables,
for perusal by other Apache modules. In addition, it can send it as response
headers to the client.

It is published under the Apache License, Version 2.0.

Source code can be obtained here: http://svn.poeml.de/svn/mod_asn/

Links:
[1] http://en.wikipedia.org/wiki/Autonomous_system_(Internet)
[2] http://en.wikipedia.org/wiki/Subnetwork
[3] http://pgfoundry.org/projects/ip4r/
[4] http://en.wikipedia.org/wiki/Radix_tree

Author: Peter Poeml


%prep
%setup -n mod_asn-%{version}

%build
%{apxs} -c mod_asn.c



%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{apache_libexecdir}
cp -p .libs/mod_asn.so $RPM_BUILD_ROOT/%{apache_libexecdir}

install -D -m 0755 asn_import.py $RPM_BUILD_ROOT/%{_bindir}/asn_import
install -D -m 0755 asn_get_routeviews.py $RPM_BUILD_ROOT/%{_bindir}/asn_get_routeviews

%files
%defattr(-,root,root)
%doc CHANGES
%doc README
%doc INSTALL
%doc asn.sql
%doc mod_asn.conf
%{apache_libexecdir}/*.so
%{_bindir}/*

%changelog
* Thu Jan  9 2014 cs@linux-administrator.com
- update to release 1.6
  - see http://mirrorbrain.org/mod_asn/docs/changes/#release-1-6-r100-jan-7-2014
* Mon Sep  6 2010 cs@linux-administrator.com
- update to release 1.5
  - see http://mirrorbrain.org/mod_asn/docs/changes/#release-1-5-r88-sep-5-2010
* Sat Mar 27 2010 cs@linux-administrator.com
- update to release 1.4
  - see http://mirrorbrain.org/mod_asn/docs/changes/#release-1-4-r79-mar-27-2010
* Thu Jul 30 2009 cs@linux-administrator.com
- update to release 1.3
  - Bugs in the asn_get_routeviews and asn_import scripts were fixed
- update to release 1.2
  - documentation updates
  - routing data snapshots are now downloaded from a mirror
    provided by mirrorbrain.org
* Tue Mar 31 2009 poeml@suse.de
- update to r22:
  - fix bug that lead to ignorance of variables in the subprocess
    environment set by ASIPEnvvar, which falsely looked for the
    wrong variable name (one that was configured via ASIPHeader).
* Tue Mar 17 2009 poeml@suse.de
- update to r21:
  - document an example how to log the looked up data
* Tue Mar 17 2009 poeml@suse.de
- update to r20:
  - updated README with documentation on design choices and
    performance.
  - INSTALL: add note about required versions of httpd and
    apr-util.
* Tue Mar 17 2009 poeml@suse.de
- update to r16:
  update README:
  - client ip override has been implemented.
  - add some reference to mod_mirrorbrain and its tool set
* Mon Mar 16 2009 poeml@suse.de
- update to r14:
  - implement lookup of IP address taken from an arbitrary HTTP
    request header, or an subprocess environment variable:
    configurable via ASIPHeader and ASIPHeader directives.
  - document the ASLookupDebug directive.
  - bump version to 1.0.
* Mon Mar 16 2009 poeml@suse.de
- update to svn r11; no functional change, mostly documentation
  updates.
* Fri Feb 13 2009 poeml@suse.de
- work on INSTALL and README
* Thu Feb 12 2009 poeml@suse.de
- work on the INSTALL docs
- README added
* Thu Feb 12 2009 poeml@suse.de
- work on the INSTALL docs
- removed accidentally checked in password (yes, it is stupid to
  put passwords in scripts, and yes, I changed it on the server)
- simplify usage of asn_get_routeviews.py
* Thu Feb 12 2009 poeml@suse.de
- initial package (0.9)
